{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 BBS Wizard Unit                                                   }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Bbswiz;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, IniFiles, Buttons, HttpProt, ZonuClass;

type
  TBBSWizard = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    TabSheet3: TTabSheet;
    Label5: TLabel;
    Label6: TLabel;
    TabSheet4: TTabSheet;
    Label9: TLabel;
    Edit1: TEdit;
    Label11: TLabel;
    ComboBox1: TComboBox;
    TabFinal: TTabSheet;
    Label12: TLabel;
    Label13: TLabel;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Image1: TImage;
    Label8: TLabel;
    Label7: TLabel;
    Label10: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    ListBox1: TListBox;
    Label15: TLabel;
    ComboBox2: TComboBox;
    TabSheet5: TTabSheet;
    Label14: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label19: TLabel;
    SubjectTxtUrl: TEdit;
    DatUrl: TEdit;
    ReadCgiUrl: TEdit;
    SendCgiUrl: TEdit;
    ThreadCgiUrl: TEdit;
    Label18: TLabel;
    Button4: TButton;
    HttpCli1: THttpCli;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
    FBoard: TBoard;
    function  GetUrl: string;
    function  GetBoardID: string;
    function  GetBoardPath: string;
    procedure AddNewSite;
  public
    { Public 錾 }
    property  NewBoard: TBoard  read  FBoard;
  end;

var
  BBSWizard: TBBSWizard;

implementation

{$R *.dfm}

uses
  ZonuConf, Hzbconst, MonaUtils, Main, Hzbclass;

procedure TBBSWizard.FormCreate(Sender: TObject);
var
  i: integer;
begin
  FBoard  :=  nil;
  PageControl1.ActivePageIndex  :=  0;
  //XNvgǉ
  for i :=  0 to  ZonuEnviron.BBSList.Count - 1 do  begin
    if  (ZonuEnviron.BBSList[i].IsPublished)  then  begin
      ListBox1.Items.Objects[ListBox1.Items.Add(ZonuEnviron.BBSList[i].ScriptName)] := ZonuEnviron.BBSList[i];
    end;
  end;
  //JeSǉ
  for i :=  0 to  ZonuEnviron.UserSite.BoardList.Count - 1 do  begin
    if  (ComboBox1.Items.IndexOf(ZonuEnviron.UserSite.BoardList[i].CategoryName) < 0)  then
    begin
      ComboBox1.Items.Add(ZonuEnviron.UserSite.BoardList[i].CategoryName);
    end;
  end;
  ComboBox2.ItemIndex :=  0;
end;

function GetIniData(BBS: TBBS; const Url,RemoteBoardID,BoardPath, SectionName: string): string;
var
  BBSini  : TMemIniFile;
  s  :  string;
begin
  BBSini  :=  TMemIniFile.Create(BBS.ConfigPath + INI_BBS);
  s       :=  BBSini.ReadString(SectionName, ExtractHostName(Url), '');
  if  (s = '')  then  begin
    s     :=  BBSini.ReadString(SectionName, '*', '');
  end;
  s :=  StringReplace(s, '<host>',
                      ExtractHostName(Url),
                      [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<bbs>',
                      RemoteBoardID,
                      [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<boardpath>',
                      BoardPath,
                      [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<PARAM_BBS>',
                      BBS.SendParam.ParamBBS,
                      [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<PARAM_DAT>',
                      BBS.SendParam.ParamDat,
                      [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<PARAM_START>',
                      BBS.SendParam.ParamStart,
                      [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<PARAM_END>',
                      BBS.SendParam.ParamEnd,
                      [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<PARAM_RES>',
                      BBS.SendParam.ParamRes,
                      [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<PARAM_NOFIRST>',
                      BBS.SendParam.ParamNoFirst,
                      [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<PARAM_TRUE>',
                      BBS.SendParam.ParamTrue,
                      [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<PARAM_FALSE>',
                      BBS.SendParam.ParamFalse,
                      [rfReplaceAll, rfIgnoreCase]);
  BBSini.Free;
  Result  :=  s;
end;

procedure TBBSWizard.Button2Click(Sender: TObject);
var
  BBS     : TBBS;
  BBSID   : string;
  //Site    : TSite;
  i : integer;
begin
  //`FbN
  if  (PageControl1.ActivePage = TabSheet1) then  begin
    //
  end else
  if  (PageControl1.ActivePage = TabSheet2) then  begin
    if  (Edit2.Text = '') then  begin
      Edit2.SetFocus;
      Exit;
    end;
  end else
  if  (PageControl1.ActivePage = TabSheet3) then  begin
    if  (Edit1.Text = '') then  begin
      Edit1.SetFocus;
      Exit;
    end else
    if  (ComboBox1.Text = '') then  begin
      ComboBox1.SetFocus;
      Exit;
    end;
  end else
  if  (PageControl1.ActivePage = TabSheet4) then  begin
    if  (ListBox1.ItemIndex < 0)  then  begin
      ListBox1.SetFocus;
      Exit;
    end else
    if  (ComboBox2.ItemIndex < 0) then  begin
      ComboBox2.SetFocus;
      Exit;
    end;
  end else
  if  (PageControl1.ActivePage = TabSheet5) then  begin

  end;

  //////////////////////////////////////////////////////////////////////////////
  //y[W؂ւ
  if  (PageControl1.ActivePage = PageControl1.Pages[PageControl1.PageCount - 2])  then
  begin
    Button2.Caption :=  '';
  end else
  if  (PageControl1.ActivePage = TabFinal)  then  begin
    AddNewSite;
    ModalResult :=  mrOk;
    Exit;
  end;
  //////////////////////////////////////////////////////////////////////////////

  PageControl1.ActivePage :=  PageControl1.Pages[PageControl1.ActivePage.PageIndex + 1];

  //////////////////////////////////////////////////////////////////////////////
  if  (PageControl1.ActivePage = TabSheet2) then  begin
    Edit2.SetFocus;
  end else
  if  (PageControl1.ActivePage = TabSheet3) then  begin
    Edit1.SetFocus;
  end else
  if  (PageControl1.ActivePage = TabSheet4) then  begin
    ListBox1.SetFocus;
    if  (AnsiPos('.jbbs.net/', Edit2.Text) > 0) then  begin
      BBSID :=  BBS_JBBS;
    end else
    if  (AnsiPos('jbbs.livedoor.com', Edit2.Text) > 0) or
        (AnsiPos('jbbs.livedoor.jp',  Edit2.Text) > 0) then
    begin
      BBSID :=  BBS_SHITARABAJBBS;
    end else
    if  (AnsiPos('www.royalserver.net', Edit2.Text) > 0) then  begin
      BBSID :=  BBS_12CH;
    end else begin
      BBSID :=  '';
    end;
      {
    if  (BBSID = '')  then  begin
      //*!*ZonuEnviron.FindIncludeSite(Edit2.Text, Site);
      if  (Site <> nil) then  begin
        BBSID :=  Site.BBS.BBSID;
      end;
    end;
      }
    if  (BBSID <> '') then  begin
      for i :=  0 to  ListBox1.Items.Count - 1  do  begin
        if  (TBBS(ListBox1.Items.Objects[i]).BBSID = BBSID) then  begin
          ListBox1.ItemIndex  :=  i;
          Break;
        end;
      end;
    end;
    if  (ListBox1.ItemIndex > -1) then  begin
      if  (TBBS(ListBox1.Items.Objects[ListBox1.ItemIndex]).Charset = csSJIS) then
      begin
        ComboBox2.ItemIndex :=  0;
      end else begin
        ComboBox2.ItemIndex :=  1;
      end;
    end else begin
      ComboBox2.ItemIndex :=  0;
    end;
  end else
  if  (PageControl1.ActivePage = TabSheet5) then  begin
    BBS     :=  TBBS(ListBox1.Items.Objects[ListBox1.ItemIndex]);
    SubjectTxtUrl.Text    :=  GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'SUBJECT');
    DatUrl.Text           :=  GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'DAT');
    ReadCgiUrl.Text       :=  GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'READCGI');
    SendCgiUrl.Text       :=  GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'SENDCGI');
    ThreadCgiUrl.Text     :=  GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'NEWTHREADCGI');
    if  (TBBS(ListBox1.Items.Objects[ListBox1.ItemIndex]).BBSID = BBS_2CH) or
        (TBBS(ListBox1.Items.Objects[ListBox1.ItemIndex]).BBSID = BBS_DOLIB) or
        (TBBS(ListBox1.Items.Objects[ListBox1.ItemIndex]).BBSID = BBS_MACHIBBS) or
        (TBBS(ListBox1.Items.Objects[ListBox1.ItemIndex]).BBSID = BBS_2CHKAKOLOG) or
        (TBBS(ListBox1.Items.Objects[ListBox1.ItemIndex]).BBSID = BBS_JBBS) then
    begin
      Button4.Enabled :=  False;
    end else begin
      Button4.Enabled :=  True;
    end;
  end;
end;

procedure TBBSWizard.Button3Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

procedure TBBSWizard.PageControl1Change(Sender: TObject);
begin
  if  (PageControl1.ActivePage = TabSheet2) then  begin
    ListBox1.SetFocus;
  end else
  if  (PageControl1.ActivePage = TabSheet3) then  begin
    Edit1.SetFocus;
  end else
  if  (PageControl1.ActivePage = TabSheet4) then  begin
    Edit2.SetFocus;
  end;
end;

procedure TBBSWizard.Button1Click(Sender: TObject);
begin
  if  (PageControl1.ActivePageIndex > 0)  then  begin
    PageControl1.ActivePageIndex  :=  PageControl1.ActivePageIndex - 1;
    if  (PageControl1.ActivePage = TabSheet2) then  begin
      Edit2.SetFocus;
    end else
    if  (PageControl1.ActivePage = TabSheet3) then  begin
      Edit1.SetFocus;
    end else
    if  (PageControl1.ActivePage = TabSheet4) then  begin
      ListBox1.SetFocus;
    end else
    if  (PageControl1.ActivePage = TabSheet5) then  begin
      SubjectTxtUrl.SetFocus;
    end;
  end;
end;

procedure _Extract(const Url: string; out BoardPath, BoardID: string);
var
  s, sx:  string;
begin
  s :=  Url;
  //http://www.2ch.net/test/index.html
  if  (ExtractFileExt(ExtractUrlName(s)) <> '') then  begin
    s :=  ExtractUrlPath(s);
  end;
  //http://www.2ch.net/test/
  if  (s[Length(s)] = '/')  then  begin
    s :=  Copy(s, 1, Length(s) - 1);
  end;
  //http://www.2ch.net/test
  sx :=  Copy(ExtractUrlPath(s), 8, Length(s));
  sx :=  Copy(sx, 1, Length(sx) - 1);
  BoardPath :=  sx;
  BoardID   :=  ExtractUrlName(s);
end;

function TBBSWizard.GetBoardID: string;
var
  s:  string;
begin
  _Extract(GetUrl, s, Result);
end;

function TBBSWizard.GetBoardPath: string;
var
  s:  string;
begin
  _Extract(GetUrl, Result, s);
end;

function TBBSWizard.GetUrl: string;
begin
  Result  :=  Edit2.Text;
end;

procedure TBBSWizard.Button4Click(Sender: TObject);
  procedure SetEnabled(const b: boolean);
  begin
    SubjectTxtUrl.Enabled     :=  b;
    DatUrl.Enabled            :=  b;
    ReadCgiUrl.Enabled        :=  b;
    SendCgiUrl.Enabled        :=  b;
    ThreadCgiUrl.Enabled      :=  b;
    Button4.Enabled           :=  b;
    Button1.Enabled           :=  b;
    Button2.Enabled           :=  b;
    Button3.Enabled           :=  b;
  end;
var
  ss: TStringStream;
  s: string;
  cgi: string;
  i: integer;
  bbsstr1 : string;
  bbsstr2 : string;
begin
  Screen.Cursor :=  crHourGlass;
  SetEnabled(False);
  ss  :=  TStringStream.Create('');
  if  (ZonuConfig.ProxyUse) then  begin
    HttpCli1.Proxy          :=  ZonuConfig.Proxy;
    HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
    HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  HttpCli1.RcvdStream       :=  ss;
  HttpCli1.Agent            :=  USER_AGENT;
  //
  s :=  GetUrl;
  i :=  ListBox1.ItemIndex;
  if  (TBBS(ListBox1.Items.Objects[i]).BBSID = BBS_2CH)  or
      (TBBS(ListBox1.Items.Objects[i]).BBSID = BBS_12CH) then
  begin
    if  (ExtractUrlName(s) = '')  then  begin
      s :=  s + 'index2.html';
    end else
    if  (ExtractUrlName(s) = 'index.html')  then  begin
      s :=  ExtractUrlPath(s) + 'index2.html';
    end;
  end;
  HttpCli1.URL  :=  s;
  try
    HttpCli1.Get;
  except
    if  (HttpCli1.StatusCode < 200) or (HttpCli1.StatusCode > 299)  then  begin
      s :=  GetUrl;
      HttpCli1.URL  :=  s;
      try
        HttpCli1.Get;
      except
        if  (HttpCli1.StatusCode < 200) or (HttpCli1.StatusCode > 299)  then  begin
          MessageDlg('擾Ɏs܂B', mtError, [mbOk], 0);
          ss.Free;
          Screen.Cursor :=  crDefault;
          SetEnabled(True);
          Exit;
        end;
      end;
    end;
  end;
  s   :=  ss.DataString;
  //read.cgi
  if  (ReadCgiUrl.Text <> '') then  begin
    cgi :=  ExtractUrlName(ReadCgiUrl.Text);
  end else
  if  (SendCgiUrl.Text <> '') then  begin
    cgi :=  ExtractUrlName(SendCgiUrl.Text);
  end;
  if  (AnsiPos('?', cgi) > 0) then  begin
    cgi :=  Copy(cgi, 1, AnsiPos('?', cgi) - 1);
  end;
  if  (AnsiPos(cgi, s) > 0) then  begin
    s :=  Copy(s, 1, AnsiPos(cgi, s) + Length(cgi) - 1);
    i :=  Length(s);
    while true  do  begin
      if  (ByteType(s, 9) = mbSingleByte) and ((s[i] = '"') or (s[i] = '''') or (s[i] = ' ') or (s[i] = '=')) then
      begin
        Break;
      end else begin
        Dec(i);
        if  (i = 0) then  Break;
      end;
    end;
    s :=  Copy(s, i + 1, Length(s));
    if  (AnsiPos('http://', s) = 0) then  begin
      s :=  MargeUrl(GetUrl, s);
    end;
  end;
  if  (s <> '')  then  begin
    if  (AnsiPos('<', s) > 0) or (AnsiPos('>', s) > 0)  then  begin
      MessageDlg('͂Ɏs܂B', mtError, [mbOk], 0);
    end else begin
      s :=  ExtractUrlPath(s);
      if  (MessageDlg('ȊłH' + #13#10 + s, mtInformation, [mbYes, mbNo], 0) = mrYes)  then  begin

        bbsstr1 :=  TBBS(ListBox1.Items.Objects[ListBox1.ItemIndex]).SendParam.ParamBBS + '=' + GetBoardID;
        bbsstr2 :=  TBBS(ListBox1.Items.Objects[ListBox1.ItemIndex]).SendParam.ParamBBS + '=<bbs>';

        if  (AnsiPos('.cgi', SubjectTxtUrl.Text) > 0) then  begin
          SubjectTxtUrl.Text  :=  StringReplace(s + ExtractUrlName(SubjectTxtUrl.Text),
                                                bbsstr1, bbsstr2, [rfReplaceAll, rfIgnoreCase]);
        end;
        if  (DatUrl.Text <> '') and (AnsiPos('.cgi', DatUrl.Text) > 0) then  begin
          DatUrl.Text       :=  StringReplace(s + ExtractUrlName(DatUrl.Text),
                                              bbsstr1, bbsstr2, [rfReplaceAll, rfIgnoreCase]);
        end;
        if  (ReadCgiUrl.Text <> '') and (AnsiPos('.cgi', ReadCgiUrl.Text) > 0) then  begin
          ReadCgiUrl.Text       :=  StringReplace(s + ExtractUrlName(ReadCgiUrl.Text),
                                                  bbsstr1, bbsstr2, [rfReplaceAll, rfIgnoreCase]);
        end;
        if  (SendCgiUrl.Text <> '') and (AnsiPos('.cgi', SendCgiUrl.Text) > 0) then  begin
          SendCgiUrl.Text       :=  StringReplace(s + ExtractUrlName(SendCgiUrl.Text),
                                                  bbsstr1, bbsstr2, [rfReplaceAll, rfIgnoreCase]);
        end;
        if  (ThreadCgiUrl.Text <> '') and (AnsiPos('.cgi', ThreadCgiUrl.Text) > 0) then  begin
          ThreadCgiUrl.Text       :=  StringReplace(s + ExtractUrlName(ThreadCgiUrl.Text),
                                                    bbsstr1, bbsstr2, [rfReplaceAll, rfIgnoreCase]);
        end;
      end;
    end;
  end;
  ss.Free;
  SetEnabled(True);
  Screen.Cursor :=  crDefault;
end;

procedure TBBSWizard.AddNewSite;
var
  BBS: TBBS;
  Board: TBoard;
  ini: TMemIniFile;
  s : string;
  i, n : integer;
  b : boolean;
begin
  Board                 :=  TBoard.Create;
  Board.Site            :=  ZonuEnviron.UserSite;
  Board.Name            :=  Edit1.Text;
  Board.BoardPath       :=  GetBoardPath;
  Board.RemoteBoardID   :=  GetBoardID;
  Board.Url             :=  GetUrl;
  Board.Key             :=  Board.BoardID;
  Board.Expanded        :=  True;
  Board.CategoryName    :=  ComboBox1.Text;
  Board.BBS             :=  TBBS(ListBox1.Items.Objects[ListBox1.ItemIndex]);
  Board.CharSet         :=  TCharSet(ComboBox2.ItemIndex);
  Board.BoardType       :=  btBBSBoard;
  //
  //  BoardID
  //
  s :=  GetBoardID;
  n :=  1;
  while true  do  begin
    for i :=  0 to  ZonuEnviron.UserSite.BoardList.Count - 1  do  begin
      if  (ZonuEnviron.UserSite.BoardList[i].BoardID = s) then  begin
        s :=  GetBoardID + IntToStr(n);
        Inc(n);
        Continue;
      end;
    end;
    Board.BoardID       :=  s;
    //Board.CachePath     :=  ZonuConfig.UsersPath + PATH_CACHE + 'user\' + Board.BoardID + '\';
    Board.CachePath     :=  ZonuConfig.CachePath + 'user\' + Board.BoardID + '\';
    Break;
  end;
  //
  //
  //
  b :=  False;
  for i :=  ZonuEnviron.UserSite.BoardList.Count - 1  downto  0  do  begin
    if  (ZonuEnviron.UserSite.BoardList[i].CategoryName = Board.CategoryName) then  begin
      b :=  True;
      ZonuEnviron.UserSite.BoardList.Insert(i, Board);
      Break;
    end;
  end;
  if  (not b) then  begin
    ZonuEnviron.UserSite.BoardList.Add(Board);
  end;

  ZonuEnviron.UserSite.BoardList.SaveToFile(ZonuEnviron.UserSite.ConfigPath + FILE_BOARD);

  //site.ini̕ҏW
  b :=  False;
  for i :=  0 to  ZonuEnviron.SiteList.Count - 1  do  begin
    if  (ZonuEnviron.SiteList[0].IsInclude(GetUrl)) then  begin
      b :=  True;
      Break;
    end;
  end;

  if  (not b) then  begin
    BBS     :=  TBBS(ListBox1.Items.Objects[ListBox1.ItemIndex]);
    ini :=  TMemIniFile.Create(ZonuEnviron.UserSite.ConfigPath + INI_SITE);

    if  (SubjectTxtUrl.Text <> '')  and
        (GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'SUBJECT') <> SubjectTxtUrl.Text)  then
    begin
      ini.WriteString('SUBJECT', ExtractHostName(GetUrl), SubjectTxtUrl.Text);
    end;

    if  (DatUrl.Text <> '')  and
        (GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'DAT') <> DatUrl.Text) then
    begin
      ini.WriteString('DAT', ExtractHostName(GetUrl), DatUrl.Text);
    end;

    if  (ReadCgiUrl.Text <> '')  and
        (GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'READCGI') <> ReadCgiUrl.Text) then
    begin
      ini.WriteString('READCGI', ExtractHostName(GetUrl), ReadCgiUrl.Text);
    end;

    if  (SendCgiUrl.Text <> '')  and
        (GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'SENDCGI') <>  SendCgiUrl.Text)  then
    begin
      ini.WriteString('SENDCGI', ExtractHostName(GetUrl), SendCgiUrl.Text);
    end;

    if  (ThreadCgiUrl.Text <> '')  and
        (GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'NEWTHREADCGI') <> ThreadCgiUrl.Text)  then
    begin
      ini.WriteString('NEWTHREADCGI', ExtractHostName(GetUrl), ThreadCgiUrl.Text);
    end;

    ini.UpdateFile;
    ini.Free;
  end;
  FBoard  :=  Board;
end;


end.
