unit Dlghead;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  THeaderFrame = class(TFrame)
    HeaderFramePanel: TPanel;
    HeaderRightImage: TImage;
    HeaderLeftImage: TImage;
    HeaderIcon: TImage;
    HeaderLabel: TLabel;
  private
    { Private 錾 }
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{$R *.dfm}

{ THeaderFrame }

constructor THeaderFrame.Create(AOwner: TComponent);
var
  AppPath: string;
begin
  inherited;
  AppPath :=  ExtractFilePath(Application.ExeName);
  if  (FileExists(AppPath + 'resource\dialogl.bmp'))  then  begin
    HeaderLeftImage.Picture.LoadFromFile(AppPath + 'resource\dialogl.bmp');
  end;
  if  (FileExists(AppPath + 'resource\dialogr.bmp'))  then  begin
    HeaderRightImage.Picture.LoadFromFile(AppPath + 'resource\dialogr.bmp');
  end;
end;

end.
