unit memchk;
//[Nojbg
//http://www.sakaki.keiaikai.or.jp/convroom/webconv.exe/read?No=9666&Response_Root=9632


// {$define Release} // [Xɒ`
interface
implementation
{$ifndef Release}
uses SysUtils, Windows;

var HeapCount: Integer;
var MemMgr, orgMemMgr: TMemoryManager;

function MyGetMem(Size: Integer): Pointer;
begin
	Inc(HeapCount);
	Result := orgMemMgr.GetMem(Size);
end;

function MyFreeMem(P: Pointer): Integer;
begin
	Result := orgMemMgr.FreeMem(P);
	Dec(HeapCount);
end;

function MyReallocMem(P: Pointer; Size: Integer): Pointer;
begin
	Result := orgMemMgr.ReallocMem( P, Size );
end;

procedure Initialize;
begin
	GetMemoryManager( orgMemMgr );
	MemMgr.GetMem			:= @MyGetMem;
	MemMgr.FreeMem		:= @MyFreeMem;
	MemMgr.ReallocMem	:= @MyReallocMem;
	SetMemoryManager( MemMgr );
end;

procedure Finalize;
begin
	SetMemoryManager( orgMemMgr );
	if HeapCount <> 0 then
		MessageBox( 0,
			PChar(Format( '%d̃[N', [HeapCount] )),
			PChar(ParamStr(0)),
			MB_OK or MB_ICONSTOP );
end;

initialization
  Initialize;
finalization
  Finalize;
{$endif}
end.
